--- linux-work/arch/i386/kernel/dmi_scan.c-o    Tue Dec 19 17:57:08 2000
+++ linux-work/arch/i386/kernel/dmi_scan.c      Thu Feb 15 11:48:06 2001
@@ -47,11 +47,17 @@
                last = dm->type;
                decode(dm);
                data+=dm->length;
-               while(*data || data[1])
-                       data++;
+               for (;;data++)  {
+                       /* if BIOS bogus tables. Check for buffer overrun. */
+                       if (data+2 > (char*)base+len || data+2 < (char*)base)
+                               goto out;
+                       if (!data[0] && !data[1])
+                               break;
+               }
                data+=2;
                i++;
        }
+out:
        iounmap(buf);
        return 0;
 }
@@ -174,9 +180,20 @@
        }
 }

+int disable_dmi;
+
 int __init dmi_scan_machine(void)
 {
+       if (disable_dmi)
+               return 0;
        return dmi_iterate(dmi_decode);
 }

+static int __init dmi_setup(char *str)
+{
+       if (!strcmp(str,"off"))
+               disable_dmi = 1;
+}
+
+__setup("dmi=", dmi_setup);
 __initcall(dmi_scan_machine);
